BroadcastAssignmentEvent2 = {};
BroadcastAssignmentEvent2_mt = Class(BroadcastAssignmentEvent2, Event);
InitEventClass(BroadcastAssignmentEvent2, "BroadcastAssignmentEvent2");

function BroadcastAssignmentEvent2:emptyNew()
    local self = Event:new(BroadcastAssignmentEvent2_mt);
    self.className = "BroadcastAssignmentEvent2";
    return self;
end;

function BroadcastAssignmentEvent2:new(fieldIndex, typeIndex, fieldArea, fruitType, stationName)
	local self = BroadcastAssignmentEvent2:emptyNew();
	self.fieldIndex = fieldIndex;
	self.typeIndex = typeIndex;
	self.fieldArea = fieldArea;
	self.fruitType = fruitType;
	self.stationName = stationName;
    return self;
end;

function BroadcastAssignmentEvent2:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.fieldIndex);
	streamWriteInt8(streamId, self.typeIndex);
	streamWriteFloat32(streamId, self.fieldArea);
	streamWriteInt8(streamId, self.fruitType);
	streamWriteString(streamId, self.stationName);
end;

function BroadcastAssignmentEvent2:readStream(streamId, connection)
	self.fieldIndex = streamReadInt8(streamId);
	self.typeIndex = streamReadInt8(streamId);
	self.fieldArea = streamReadFloat32(streamId);
	self.fruitType = streamReadInt8(streamId);
	self.stationName = streamReadString(streamId);
	self:run(connection);
end;

function BroadcastAssignmentEvent2:run(connection)
	local assignment = {}
	assignment.fieldIndex = self.fieldIndex;
	assignment.field = g_currentMission.fieldDefinitionBase.fieldDefs[assignment.fieldIndex];
	assignment.type = AssignmentTypes[self.typeIndex];
	assignment.fruitType = self.fruitType;
	assignment.progress = 0;
	assignment.haToWorkOn = self.fieldArea;
	assignment.price = math.floor(assignment.haToWorkOn * assignment.type.pricePerHa);
	if assignment.type.checkDeliveryFunction ~= nil then
		assignment.delivery = {}
		assignment.delivery.stationName = self.stationName;
		assignment.delivery.progress = 0;
		assignment.delivery.surchargeFactor = 0.3;
		assignment.delivery.surcharge = assignment.price * assignment.delivery.surchargeFactor;
	end;
	assignment.briefing = g_currentMission.fieldWorkMissions:getAssignmentBriefing(assignment);
	g_currentMission.fieldWorkMissions:acceptAssignment(assignment);
end;