SetSelectedAssignmentTypeEvent = {};
SetSelectedAssignmentTypeEvent_mt = Class(SetSelectedAssignmentTypeEvent, Event);
InitEventClass(SetSelectedAssignmentTypeEvent, "SetSelectedAssignmentTypeEvent");

function SetSelectedAssignmentTypeEvent:emptyNew()
    local self = Event:new(SetSelectedAssignmentTypeEvent_mt);
    self.className = "SetSelectedAssignmentTypeEvent";
    return self;
end;

function SetSelectedAssignmentTypeEvent:new(index)
    local self = SetSelectedAssignmentTypeEvent:emptyNew();
	self.index = index;
    return self;
end;

function SetSelectedAssignmentTypeEvent:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.index);
end;

function SetSelectedAssignmentTypeEvent:readStream(streamId, connection)
	self.index = streamReadInt8(streamId);
	self:run(connection);
end;

function SetSelectedAssignmentTypeEvent:run(connection)
	g_currentMission.assignmentSettingsHUD:setSelectedAssignmentTypeIndex(self.index, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetSelectedAssignmentTypeEvent:new(self.index), nil, connection, nil);
	end;
end;

function SetSelectedAssignmentTypeEvent.sendEvent(index, noEventSend)
	if not noEventSend then
		if g_server ~= nil then
			g_server:broadcastEvent(SetSelectedAssignmentTypeEvent:new(index), nil, nil, nil);
		else
			g_client:getServerConnection():sendEvent(SetSelectedAssignmentTypeEvent:new(index));
		end;
	end;
end;