UpdateAssignmentProgressEvent = {};
UpdateAssignmentProgressEvent_mt = Class(UpdateAssignmentProgressEvent, Event);
InitEventClass(UpdateAssignmentProgressEvent, "UpdateAssignmentProgressEvent");

function UpdateAssignmentProgressEvent:emptyNew()
    local self = Event:new(UpdateAssignmentProgressEvent_mt);
    self.className = "UpdateAssignmentProgressEvent";
    return self;
end;

function UpdateAssignmentProgressEvent:new(assignment)
    local self = UpdateAssignmentProgressEvent:emptyNew();
	self.assignment = assignment;
    return self;
end;

function UpdateAssignmentProgressEvent:writeStream(streamId, connection)
	streamWriteInt8(streamId, math.floor(self.assignment.progress));
	if streamWriteBool(streamId, self.assignment.delivery ~= nil) then
		streamWriteInt8(streamId, math.floor(self.assignment.delivery.progress));
	end;
end;

function UpdateAssignmentProgressEvent:readStream(streamId, connection)
	local progress = streamReadInt8(streamId);
	if g_currentMission.fieldWorkMissions.currentAssignment ~= nil then
		g_currentMission.fieldWorkMissions.currentAssignment.progress = progress;
	end;
	if streamReadBool(streamId) and g_currentMission.fieldWorkMissions.currentAssignment ~= nil then
		g_currentMission.fieldWorkMissions.currentAssignment.delivery.progress = streamReadInt8(streamId);
	end;
	if g_currentMission.fieldWorkMissions.currentAssignment ~= nil then
		g_currentMission.assignmentHUD:updateHUDValues();
	end;
end;