-- author: rafftnix
-- date: 12.01.2016

-- sowing machine seed type fix
-- sets the sowing machine's current seed type to whatever the current assignment assigns you to seed


local oldSowingMachineUpdateTick = SowingMachine.updateTick;
SowingMachine.updateTick = function(self, dt)
	oldSowingMachineUpdateTick(self, dt);
	if self:getIsActive() then
		if g_currentMission.fieldWorkMissions.currentAssignment ~= nil and g_currentMission.fieldWorkMissions.currentAssignment.fruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
			if g_currentMission.fieldWorkMissions.currentAssignment.assignmentType == g_currentMission.fieldWorkMissions.assignments.seeding then			
				local fieldIndex = g_currentMission.fieldWorkMissions.currentAssignment.fieldIndex;
				local x, y, z = getWorldTranslation(self.components[1].node);
				local isOnField = g_currentMission.fieldWorkMissions:getIsVehicleOnField(fieldIndex, x, z);
				if self.isServer and self.allowsSeedChanging and isOnField then
					local fruitType = g_currentMission.fieldWorkMissions.currentAssignment.fruitType;
					for k, v in pairs(self.seeds) do
						if v == fruitType then
							self:setSeedIndex(v);
							break;
						end;
					end;
				end;
				self.allowsSeedChangingBackup = self.allowsSeedChanging;
				self.allowsSeedChanging = not isOnField;
			end;
		end;
		if g_currentMission.fieldWorkMissions.currentAssignment == nil then
			if self.allowsSeedChangingBackup ~= nil then
				self.allowsSeedChanging = self.allowsSeedChangingBackup;
			end;
		end;
	end;
end;