-- assignmentHUD.lua
-- author: rafftnix 
-- date: 05.06.2013

-- Keine Vernderung ohne meine Erlaubnis!
-- No modification without my permission!
-- history: 
--  		v1.0 (August 2013 - GIANTS mod contest hand in)


AssignmentHUD = {}

local AssignmentHUD_mt = Class(AssignmentHUD);

function AssignmentHUD:new()
	local self = {};
	setmetatable(self, AssignmentHUD_mt);

	g_currentMission.assignmentHUD = self;
	
	self.gui = RafftnixGUI:new(nil, false, false);
	self.base = self.gui:createElement(self.gui.baseElement, 0.35, 0.9, 0, 0);
	
	self.currentAssignment = nil;
	self.backGroundImage = self.gui:createImage(self.base, -0.005, -0.005, 0.3, 1, "GUI/assignmentHUD.dds");
	self.assignmentText = self.gui:createText(self.base, 0, 0.075, 0.0, 0.0, "Auftrag: Dreschen sie alle Felder", 0.02, 1);
	self.progressText = self.gui:createText(self.base, 0, 0.025, 0.0, 0.0, "Zu X Prozent erledigt", 0.02, 1);
	self.deliverProgressText = self.gui:createText(self.base, 0, 0, 0.0, 0.0, "Ernte zu X Prozent abgeliefert", 0.02, 1);

	return self;
end;

function AssignmentHUD:open(assignment)
	self.gui:open();
	self.currentAssignment = assignment;
	self:updateHUDValues();
end;

function AssignmentHUD:close()
	self.gui:close();
end;

function AssignmentHUD:updateHUDValues()
	local assignment = self.currentAssignment;
	self.assignmentText:setText(assignment.briefing);

	local percentDone = nil;
	if (assignment.progress/100) > (1-g_currentMission.fieldWorkMissions.assignmentWorkTolerance) then
		percentDone = g_i18n:getText("fieldworkDone");
	else
		percentDone = string.gsub(g_i18n:getText("percentDone"), "progress", tostring(math.floor(assignment.progress*100)/100)); 
	end;
	
	self.progressText:setText(percentDone);
	
	if assignment.delivery ~= nil then
		progressText = tostring(math.min(100, math.floor(assignment.delivery.progress*100)/100));
		local deliverProgress = string.gsub(g_i18n:getText("deliverProgress"), "progress", progressText); 
		self.deliverProgressText:setText(deliverProgress);
		self.deliverProgressText:setVisibility(true);
	else
		self.deliverProgressText:setVisibility(false);
	end;
end;