-- author: rafftnix
-- date: 26.12.2014

-- tipTriggerUpdateTrailerTippingTweak.lua

local tipTriggerUpdateTrailerTipping = TipTrigger.updateTrailerTipping;
TipTrigger.updateTrailerTipping = function (self, trailer, fillDelta, fillType)
	if g_currentMission.fieldWorkMissions ~= nil and g_currentMission.fieldWorkMissions.currentAssignment ~= nil then
		local assignment = g_currentMission.fieldWorkMissions.currentAssignment;
		if assignment.delivery ~= nil and assignment.delivery.triggerCheck[self] == true and assignment.delivery.expectedFillType == fillType then
			local amount = math.min(math.abs(fillDelta), assignment.delivery.harvestedAmount-assignment.delivery.deliveredAmount);
			assignment.delivery.deliveredAmount = assignment.delivery.deliveredAmount + amount;
			if math.abs(fillDelta) > amount then
				return tipTriggerUpdateTrailerTipping(self, trailer, fillDelta-amount, fillType);
			else
				return;
			end;
		end;
	end;
	
	return tipTriggerUpdateTrailerTipping(self, trailer, fillDelta, fillType);
end;

local bunkerSiloUpdateTrailerTipping = BunkerSiloTipTrigger.updateTrailerTipping;
BunkerSiloTipTrigger.updateTrailerTipping = function(self, trailer, fillDelta, fillType)
	if g_currentMission.fieldWorkMissions ~= nil and g_currentMission.fieldWorkMissions.currentAssignment ~= nil then
		local assignment = g_currentMission.fieldWorkMissions.currentAssignment;
		if assignment.delivery ~= nil and assignment.delivery.triggerCheck[self] == true and assignment.delivery.expectedFillType == fillType then
			local amount = math.min(math.abs(fillDelta), assignment.delivery.harvestedAmount-assignment.delivery.deliveredAmount);
			assignment.delivery.deliveredAmount = assignment.delivery.deliveredAmount + amount;
			if math.abs(fillDelta) > amount then
				return bunkerSiloUpdateTrailerTipping(self, trailer, fillDelta, fillType);
			else
				return;
			end;
		end;
	end;
	
	return bunkerSiloUpdateTrailerTipping(self, trailer, fillDelta, fillType);
end;

-- TipTrigger:load() fix to make it possible to keep out certain triggers
local oldTipTriggerLoad = TipTrigger.load;
TipTrigger.load = function(self, id, param1, param2, param3)
	self.doNotUseForAssignments = Utils.getNoNil(getUserAttribute(id, "doNotUseForAssignments"), false);
	return oldTipTriggerLoad(self, id, param1, param2, param3);
end;